{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 63384,0,655360}

program JUH;

type Matr = array [1..33, 1..33] of longint;


var n: integer;
    g, o: array [1..33, 1..33] of byte;
  inf: array [1..33, 1..33] of boolean;
    m, m1, mr, oldmr: Matr;
    cmp: comp;

procedure ReadAll;
var xx, yy: integer;
begin
  assign (input, 'input.txt'); reset (input);
  FillChar (g, sizeof (g), 0);
    read (input, n);
    while not seekeof (input) do
    begin
      read (xx, yy);
      g[xx, yy] := 1;
    end;
  close (input);
end;


procedure Yops;
var i, j, k: integer;
begin
  for i := 1 to n do
    for j := 1 to n do
      begin
        m1 [i, j] := 0;
        for k := 1 to n do
          if g [k, j] > 0 then m1[i, j] := m1[i, j] + m [i, k];
        if inf [i, j] and (m1 [i, j] > 100000) then m1[i,j] := 100000;
      end;
  m := m1;
end;

procedure InitM;
var i, j: integer;
begin
  for i := 1 to n do
    for j := 1 to n do
      m [i, j] := g[i, j];
  Mr := m;
end;

procedure AddM;
var i, j: integer;
begin
  for i := 1 to n do
    for j := 1 to n do
       if inf[i, j] = false then mr [i, j]  := mr[i, j] + m[i, j];
end;

procedure FindInfinite;
var i, j, k: integer;
begin
  FillChar (inf, sizeof (inf), 0);
  for k := 1 to n do
    if o [k, k] <> 0 then
  begin
    for i := 1 to n do
      for j := 1 to n do
        if (o[i, k] > 0) and (o [k, j] > 0) then inf [i, j] := true;
  end;
end;

procedure Floyd;
var i, j, k: integer;
begin
  o := g;
  for k := 1 to n do
    for i := 1 to n do
      for j := 1 to n do
        if (o[i,k] > 0) and (o[k, j] > 0) then
            begin
              if (o[i, j] = 0) or (o[i,k] + o[k, j] < o[i, j]) then
                   o[i, j] := o[i, k] + o[k, j];
            end;
end;

function NoChanges: boolean;
var i, j: integer;
begin
  NoChanges := false;
    for i := 1 to n do
      for j := 1 to n do
        if (inf[i, j] = false) and (mr[i, j] <> oldmr [i, j]) then exit;
  NoChanges := true;
end;

procedure Solve;
var i: integer;
begin
  Floyd;
  FindInfinite;
  InitM;
  repeat
    OldMr := Mr;
    Yops;
    AddM;
  until NoChanges;
end;

procedure PrintOut;
var i, j: integer;
begin
  assign (output, 'output.txt'); rewrite (output);
  for i := 1 to n do
  begin
   for j := 1 to n do
    if inf [i, j] then write ('-1 ') else
         if mr [i, j] >= 0 then
           write (mr[i, j],' ') else
            begin
              cmp := mr[i, j];
              cmp := -cmp;
              write (cmp:0:0, ' ');
            end;
    writeln;
  end;
  close (output);
end;

begin
  ReadAll;
  Solve;
  PrintOut;
end.